Subject: Auto-generate TypoScript code for node types
Description

A new or changed node type needs an according change to the TypoScript code. To make this process as easy as possible the basic
TypoScript code for rendering nodes should be auto-generated.

    -  Reduce the overhead when implementing node types
    -  Have extensible TypoScript objects per default, instead of using {node.properties.example} as a shortcut
    -  No rendering errors because of missing TypoScript definitions

Associated revisions
Revision 82dd00ce - 2013-11-11 18:21 - Christopher Hlubek

[!!!][FEATURE] Auto-generate TypoScript from node type configuration

This change refactors the TypoScriptService for easier testing in the
RenderingTest and adds the feature of auto-generating TypoScript from the
node type configuration.

The generated code for node types is the following::
prototype(TYPO3.Neos.NodeTypes:Text) < prototype(TYPO3.Neos:Template) {
        templatePath = 'resource://TYPO3.Neos.NodeTypes/Private/Templates/NodeTypes/Text.html'
        text = ${node.properties.text}
    }

This is non-breaking as long as the prototype for a node type does not
use Array or another TypoScript object, where the additional properties
of the auto-generated code could produce unwanted output during rendering.

For these cases it is sufficient to reset the prototype definition in
front of the custom declaration::

prototype(TYPO3.Neos:Page) >
    prototype(TYPO3.Neos:Page) < prototype(TYPO3.TypoScript:Array) {
        ...
    }

Due to the changed way of merging the TypoScript relative paths in
"include" statements might need to be changed. Relative paths are
always resolved from the directory of the current file.
History
#1 - 2013-11-04 18:52 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.Neos has been pushed to the review server.
It is available at https://review.typo3.org/25161

#2 - 2013-11-05 09:28 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.Neos has been pushed to the review server.
It is available at https://review.typo3.org/25161

#3 - 2013-11-05 12:57 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.Neos has been pushed to the review server.
It is available at https://review.typo3.org/25161

#4 - 2013-11-11 12:03 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.Neos has been pushed to the review server.
It is available at https://review.typo3.org/25161

#5 - 2013-11-11 12:30 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.Neos has been pushed to the review server.
It is available at https://review.typo3.org/25161

#6 - 2013-11-11 18:13 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.Neos has been pushed to the review server.
It is available at https://review.typo3.org/25161

#7 - 2013-11-11 18:17 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.Neos has been pushed to the review server.
It is available at https://review.typo3.org/25161

#8 - 2013-11-11 18:36 - Christopher Hlubek
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:82dd00cee4c089d5fba85bc4f705bb577ba13d43.
